#version 440 core

in vec2 vf_position;
flat in int vf_wave_index;
in float vf_bound_ratio;
in vec2 vf_translation;

uniform sampler2D wave_height_texture;

layout(location=0) out float wave_height;

void main(void)
{
	// Compute radius at current pixel
	vec2 tc = vec2((length(vf_position) - vf_bound_ratio) / (1 - vf_bound_ratio),
		(float(vf_wave_index) + 0.5f) / textureSize(wave_height_texture, 0).y);

	// Compute random amplitude
	vec2 rand_vec = fract(vf_translation*1000);
	float rand_num = 0.5 * (rand_vec.x + rand_vec.y);
	float rand_ampl = rand_num*rand_num + 0.01;

	// Do lookup in wave-height buffer
	wave_height = rand_ampl * texture(wave_height_texture, tc).r;
}