#version 440 core

layout(location=0) in vec2 position;
layout(location=1) in vec2 translation;
layout(location=2) in vec3 wave_data;

uniform float R_star;

out vec2 vf_position;
flat out int vf_wave_index;
out float vf_bound_ratio;
out vec2 vf_translation;

uniform mat4 mvp_matrix;

// This shader draws a quad in screen-space and renders the wave height in the red color component
void main(void)
{
	// Determine size of wave quaad
	float t = wave_data.z;
	float r_star_max = wave_data[1] * R_star;

	vec2 p = 2 * r_star_max * position + translation;
	vf_position = 2 * position;
	vf_wave_index = gl_InstanceID;
	vf_bound_ratio = wave_data[0] / wave_data[1];
	// Transform quad to clip coordinates
	gl_Position = mvp_matrix * vec4(p.y, 0.0, p.x, 1.0);
	vf_translation = translation;
}