#pragma once

#include <nanogui/nanogui.h>

class Camera
{
public:
	Camera(const Eigen::Vector3f& pivot = Eigen::Vector3f(0.f,0.f,0.f));

	void setScreenSize(const Eigen::Vector2f& size);
	const Eigen::Matrix4f& getVPMatrix() const { return vp_matrix; }

	void increaseAngles(const Eigen::Vector2f& incr);
	void increaseAngles(float incr_azimuth, float incr_polar);
	void increasePivot(const Eigen::Vector3f& incr_pivot);
	void setRadius(float rad);
	inline float getRadius() const { return radius; }
	inline const Eigen::Vector3f& getPosition() const { return position; }
	void getCornerDirections(Eigen::Vector3f& ll, Eigen::Vector3f& lr, Eigen::Vector3f& ul, Eigen::Vector3f& ur) const;
	const Eigen::Vector3f& getDirection(int i) const;

private:
	Eigen::Vector3f pivot, position;
	float polar, azimuth, radius;
	Eigen::Matrix4f view_matrix, projection_matrix, vp_matrix;
	Eigen::Vector2f screen_size;
	float opening_angle;
	float far_dist, near_dist;
	Eigen::Vector3f dirx, diry, dirz;
	float fracx, fracy; // n/r, n/t

	void update(bool view = true, bool proj = true);
};