#include "GLFramebuffer.h"

using namespace rgl;

GLFramebuffer::GLFramebuffer()
{
	glGenFramebuffers(1, &name);
}

GLFramebuffer::~GLFramebuffer()
{
	glDeleteFramebuffers(1, &name);
}

void GLFramebuffer::printFramebufferCompleteMessage() const
{
	bind();
	auto framebuffer_status = glCheckFramebufferStatus(GL_FRAMEBUFFER);
	if (framebuffer_status == GL_FRAMEBUFFER_COMPLETE)
		std::cout << "Water Height Framebuffer ok" << std::endl;
	else
		std::cout << "Water Height Framebuffer NOT ok" << std::endl;
}

void GLFramebuffer::attach(const GLTexture2D& texture, GLenum attachment, int level)
{
	glBindFramebuffer(GL_FRAMEBUFFER, name);
	glFramebufferTexture(GL_FRAMEBUFFER, attachment, texture.name, level);
}

void GLFramebuffer::setDrawBuffer(GLenum buf)
{
	glBindFramebuffer(GL_FRAMEBUFFER, name);
	GLenum bufs[] = { buf };
	glDrawBuffers(1, bufs);
}

void GLFramebuffer::bind() const
{
	glBindFramebuffer(GL_FRAMEBUFFER, name);
}