#pragma once

#include "GLTexture.h"

namespace rgl
{
	class GLFramebuffer
	{
	public:
		GLFramebuffer();
		~GLFramebuffer();

		void attach(const GLTexture2D& texture, GLenum attachment, int level = 0);
		void setDrawBuffer(GLenum buf);
		void bind() const;

		inline GLuint getName() const { return name; }
		void printFramebufferCompleteMessage() const;

		static void unbind() { glBindFramebuffer(GL_FRAMEBUFFER, 0); }

	private:
		GLuint name;
	};
}