#include "Images.h"
#include "lodepng.h"
#include <iostream>
#include <algorithm>

void Images::loadPNG(const std::string& path,
	std::vector<unsigned char>& data, unsigned int& width, unsigned int& height)
{
	unsigned error = lodepng::decode(data, width, height, path);
	if (error != 0)
		std::cout << "Error reading " << path << "." << std::endl;
	Images::swapVertical(data, width, height);
}

void Images::swapVertical(std::vector<unsigned char>& data, unsigned int width, unsigned int height, unsigned int num_channels)
{
	unsigned w4 = width * 4;
	for (unsigned int row = 0; row < height / 2u; row++)
	{
		std::swap_ranges(data.begin() + row * w4, data.begin() + (row + 1) * w4,
			data.begin() + (height - row - 1) * w4);
	}
}

void Images::savePNG(const std::string& path, std::vector<unsigned char>& data, unsigned int width, unsigned int height, unsigned int num_channels)
{
	Images::swapVertical(data, width, height, num_channels);
	unsigned error = lodepng::encode(path, data, width, height);
	if (error != 0)
		std::cout << "Error writing " << path << "." << std::endl;
}