#include "MathHelper.h"

double MathHelper::newtonsMethod(std::function<double(double)> f, std::function<double(double)> df, double val, double p, double tol, unsigned max_iter)
{
	auto v = f(p) - val;
	auto iter = 0u;
	while ((v > tol || v < -tol) && iter++ < max_iter)
	{
		auto tmep = df(p);
		p = p - v / tmep;
		v = f(p) - val;
	}
	return p;
}