#include "WaveQuad.h"

WaveQuad::WaveQuad()
	: t_star(0.0)
{
	auto r = []() {return static_cast <float> (rand()) / static_cast <float> (RAND_MAX); };
	position = Eigen::Vector2f(-3.f + 6.f*r(), -3.f + 6.f*r());
	update(0.0f);
}

WaveQuad::WaveQuad(const Eigen::Vector2f& position)
	: t_star(0.0), position(position)
{
	update(0.0f);
}

void WaveQuad::update(double dt)
{
	t_star += dt;
	// t_star = 2.24f;
}

bool WaveQuad::isFinished() const
{
	return t_star > t_star_max;
}

const double WaveQuad::t_star_max = 10.0;